# Contributing

We'd love for you to contribute and to make this project even better than it is today! If this interests you, please make sure to follow the steps below before creating a Pull Request.

When we mention `VSCode`, we mean `Visual Studio Code` editor which can be downloaded [here](https://code.visualstudio.com)

Before accepting any Pull Request, we need to make sure that you followed these steps:
1. Install dependencies
```sh
npm install
```
2. Run a full build
```sh
npm run build:prod
```
3. Fix any Lint or TypeScript issues (if any)
4. If you did step 2 and 3, then the final step would be go ahead with the Pull Request
   - **Note** even though the `dist/` folder is included in Git, you could choose to ignore these files from the Pull Request.